package com.app.input.personalised.board.listhelpers;


import android.content.Context;
import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.app.input.personalised.board.R;
import com.app.input.personalised.board.databean.KeyboardTheme;
import com.app.input.personalised.board.databinding.ItemHomeSectionBinding;
import com.app.input.personalised.board.boartactivity.ThemeDetailActivity;
import com.app.input.personalised.board.helpers.AppUtils;
import com.bumptech.glide.Glide;

import java.util.ArrayList;
import java.util.List;

public class ThemePreviewAdapter extends RecyclerView.Adapter<ThemePreviewAdapter.ChildViewHolder> {

    private Context mContext;
    private List<KeyboardTheme> mList = new ArrayList<>();


    public ThemePreviewAdapter(Context context, List<KeyboardTheme> list) {
        mContext = context;
        this.mList = list;
    }


    @NonNull
    @Override
    public ChildViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ItemHomeSectionBinding inflate = ItemHomeSectionBinding.inflate(LayoutInflater.from(parent.getContext()));


        return new ChildViewHolder(inflate);
    }

    @Override
    public void onBindViewHolder(@NonNull ChildViewHolder holder, int position) {
        KeyboardTheme beanDetails = mList.get(position);


        String thumbGif = beanDetails.getThumbGif();
        String thumb = beanDetails.getThumbUrl();
        if (!thumbGif.isEmpty()) {
            AppUtils.INSTANCE.loadWepJif(mContext, thumbGif, holder.binding.imageView);
        } else {
            Glide.with(mContext).load(thumb)
                    .error(R.drawable.placeholder)
                    .placeholder(R.drawable.placeholder)
                    .into(holder.binding.imageView);
        }

        holder.binding.fragme.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intentApply = new Intent(mContext, ThemeDetailActivity.class);
                intentApply.putExtra(ThemeDetailActivity.SOURCE_KEY, beanDetails);
                intentApply.putExtra(ThemeDetailActivity.DISPLAY_URL_KEY, beanDetails.getImgPath());
                intentApply.putExtra(ThemeDetailActivity.ZIP_URL_KEY, beanDetails.getZipPath());
                intentApply.putExtra(ThemeDetailActivity.NAME_KEY, beanDetails.getTitleName());
                intentApply.putExtra(ThemeDetailActivity.GIF_KEY, beanDetails.getImgGif());
                String intent_thumb;
                if (!thumbGif.isEmpty()) {
                    intent_thumb = thumbGif;
                } else {
                    intent_thumb = thumb;
                }
                intentApply.putExtra(ThemeDetailActivity.THUMB_KEY, intent_thumb);
                mContext.startActivity(intentApply);


            }
        });


    }

    @Override
    public int getItemCount() {
        return mList.size();
    }

    public static class ChildViewHolder extends RecyclerView.ViewHolder {

        private ItemHomeSectionBinding binding;


        public ChildViewHolder(@NonNull ItemHomeSectionBinding itemView) {
            super(itemView.getRoot());
            binding = itemView;


        }

    }

//    private void loadWepJif(String webpGifUrl,ImageView view){
//        Glide.with(mContext).load(webpGifUrl).addListener(new RequestListener<Drawable>() {
//            @Override
//            public boolean onLoadFailed(@Nullable GlideException e, @Nullable Object model, @NonNull Target<Drawable> target, boolean isFirstResource) {
//                return false;
//            }
//
//            @Override
//            public boolean onResourceReady(@NonNull Drawable resource, @NonNull Object model, Target<Drawable> target, @NonNull DataSource dataSource, boolean isFirstResource) {
//               if(resource instanceof WebpDrawable){
//                   WebpDrawable webpDrawable = (WebpDrawable) resource;
//                   webpDrawable.setLoopCount(LOOP_FOREVER);
//               }
//
//                return false;
//            }
//        }).into(view);
//    }
}
